if SERVER then
	sphericalenvs = { --Add your spherical environments here
		"star",
		"planet",
		"planet2",
		"star2"
	}
	cubicalenvs = { --Add your cube shaped environments here
		"cube"
	}
	conicalenvs = {} --Not yet implented, testing just how many people would actually find an use on this.

	--Variables
	ToggleSimpleSpace = false --Don't change this, it will break
	PlayerNoclip = true --The following you can edit though
	AdminNoclip = false


	--Other Variables
	Version = 2.2
	local planets = {}
	local EntsNotInSpace = {}




	local function ToggleSpace( ply, args, cmd )
		if ply:IsAdmin() then
			if ToggleSimpleSpace then
				ToggleSimpleSpace = false
			else
				ToggleSimpleSpace = true
			end
		end
	end
	concommand.Add( "SS_TOGGLE", ToggleSpace )
	
	local function ToggleNoclip( ply, args, cmd )
		if ply:IsAdmin() then
			if PlayerNoclip then
				PlayerNoclip = false
			else
				PlayerNoclip = true
			end
		end
	end
	concommand.Add( "SS_PLAYERNOCLIP", ToggleNoclip )
	
	local function ToggleAdminNoclip( ply, args, cmd )
		if ply:IsSuperAdmin() then
			if !PlayerNoclip and AdminNoclip then
				AdminNoclip = false
			else
				AdminNoclip = true
			end
		end
	end
	concommand.Add( "SS_ADMINNOCLIP", ToggleAdminNoclip )
	

	local function BlockNoclip( ply )
		if !PlayerNoclip and ToggleSimpleSpace then
			if ply:GetNWBool( "inspace" ) then
				if AdminNoclip then
					return ply:IsAdmin()
				else
					ply:SetMoveType( MOVETYPE_WALK )
					return false
				end
			end
		end
	end
	hook.Add("PlayerNoClip", "BlockNoclip", BlockNoclip)




	local function AddAllPlanets()
		local entities = ents.FindByClass( "logic_case" )

		for _,p in pairs(entities) do

			planet = {}
			planet.position = p:GetPos()


			for k, v in pairs( p:GetKeyValues() ) do

				if ( (k == "Case01") and table.HasValue(table.Add(sphericalenvs,cubicalenvs ),v) ) then
					table.insert( planets, planet )--Put this current planet in the list of planets

					--Define the type of planet
					if table.HasValue( sphericalenvs, v ) then
						planet.typeof = "sphere"
					elseif table.HasValue( cubicalenvs, v ) then
						planet.typeof = "cube"
					end

				elseif (k == "Case02") then --Get its radius
					planet.radius = tonumber(v) 
				elseif (k == "Case03") then --Get its gravity
					planet.gravity = tonumber(v)
				end

			end

		end


		if table.Count( planets ) or 0 > 0 then
			ToggleSimpleSpace = true
		end

		print( "[SimpleSpace "..Version.."]Initilizing..." )
		--print( util.TableToKeyValues( planets ) )
	end
	hook.Add( "InitPostEntity", "AddAllPlanets", AddAllPlanets )

	

	local function ApplyForce()
		if ToggleSimpleSpace then

			for _, e in pairs( ents.GetAll() ) do

				if( e:GetPhysicsObject():IsValid() and !e:IsWorld() and !e:IsWeapon() and e:GetTable()!=nil ) then
					if( !e:GetTable().sgravity ) then
						if( e:IsPlayer() ) then

							e:SetGravity( 0.000000001 )

							if( PlayerNoclip ) then
								if( AdminNoclip and !e:IsAdmin() ) then
									e:SetMoveType( MOVETYPE_WALK )
								end
							else
								e:SetMoveType( MOVETYPE_WALK )
							end
							e:SetNWBool( "inspace", true )
						else
							--e:GetPhysicsObject():EnableGravity( false )
							--e:GetPhysicsObject():EnableDrag( false )

						end

						local entities = ents.FindByClass( "logic_case" )


						for _,p in pairs(entities) do
						
							position = Vector(e:GetPos()[1], e:GetPos()[2], e:GetPos()[3])
							local Distance = position.Distance
							local validEntity = validEntity
							table.sort(entities, function(a, b)
								if not validEntity(a) then return false end -- !(invalid < b) <=> (b <= invalid)
								if not validEntity(b) then return true end -- (valid < invalid)

								return Distance(position, a:GetPos()) < Distance(position, b:GetPos())
							end)


							
						end


						--Force!
						local F = 30 * ( (planet.gravity * e:GetPhysicsObject():GetMass()) / e:GetPos():Distance(entities[1]:GetPos()) )
						if(e:IsPlayer())then
							e:SetVelocity((entities[1]:GetPos() - e:GetPos()) * (e:GetPhysicsObject():GetMass()*0.0001))
						elseif(!e:IsPlayer() ) then
							--Ignore props with certain constraints(Wire hydros), as they cause crashing

						if constraint.FindConstraint(e, "WireHydraulic") then --and e:GetPhysicsObject():GetMass()<25 then
						
						else
							e:GetPhysicsObject():EnableGravity( false )
							e:GetPhysicsObject():EnableDrag( false )
						end

						if constraint.FindConstraint( e, "WireHydraulic") then
							--e:SetColor(Color(255,0,0))
						else
							--e:SetColor(Color(0,255,0))

							--F = G * ( (M1 * M2)/(R^2) ) --0.00000000006674
							e:GetPhysicsObject():ApplyForceCenter((entities[1]:GetPos() - e:GetPos())*F)
						end
						end
					end

					e:GetTable().sgravity = false

				end
			end
		end
	end
	
	local function GravityCheck()
		if ToggleSimpleSpace then
			for _, p in pairs( planets ) do
				if p.typeof == "sphere" then
					EntsNotInSpace = ents.FindInSphere( p.position, p.radius )
				end
				if p.typeof == "cube" then
					EntsNotInSpace = ents.FindInBox( Vector( p.radius, p.radius, p.radius ) - p.position, p.position + Vector( p.radius, p.radius, p.radius ) )
				end

				for _, e in pairs( EntsNotInSpace ) do

					if( e:GetPhysicsObject():IsValid() and !e:IsWorld() and !e:IsWeapon() ) then

						e:SetGravity( p.gravity )
						e:GetPhysicsObject():EnableGravity( true )
						e:GetTable().sgravity = true

						if( e:IsPlayer() ) then
							e:SetNWBool( "inspace", false )
						end
					end

				end
			end

			ApplyForce()
		end
	end

	timer.Create("GravityCheck", 0.1, 0, GravityCheck )
	
end